"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exceptObject = exports.exceptString = exports.exceptArray = void 0;
const _ = require("lodash");
const exceptArray = (v, opts = {}) => {
    var _a;
    const { defaultValue = [], splitor = ',', transToArrayFn = v => _.split(v, splitor) } = opts;
    let result = defaultValue;
    let input = v;
    if (_.isFunction(input)) {
        input = (_a = v(opts)) !== null && _a !== void 0 ? _a : defaultValue;
    }
    if (_.isArray(input)) {
        result = input;
    }
    else if (_.isString(input)) {
        result = transToArrayFn(input, opts, splitor);
    }
    else if (_.isNumber(input)) {
        result = [input];
    }
    else if (_.isObject(input)) {
        result = [input];
    }
    return result;
};
exports.exceptArray = exceptArray;
const exceptString = (v, opts) => {
    var _a;
    const { defaultValue = '', splitor = ',', transToStringFn = v => JSON.stringify(v, null, 2) } = opts !== null && opts !== void 0 ? opts : {};
    let result = defaultValue;
    let input = v;
    if (_.isFunction(input)) {
        input = (_a = v(opts)) !== null && _a !== void 0 ? _a : defaultValue;
    }
    if (_.isArray(input)) {
        result = _.join(input, splitor);
    }
    else if (_.isString(input)) {
        result = input;
    }
    else if (_.isNumber(input)) {
        result = input + '';
    }
    else if (_.isObject(input)) {
        result = transToStringFn(input, opts);
    }
    return result;
};
exports.exceptString = exceptString;
const exceptObject = (v, opts = {}) => {
    var _a;
    const { defaultValue = {}, transToObjectFn = v => JSON.parse(v) } = opts;
    let result = defaultValue;
    let input = v;
    if (_.isFunction(input)) {
        input = (_a = v(opts)) !== null && _a !== void 0 ? _a : defaultValue;
    }
    if (_.isString(input)) {
        result = transToObjectFn(input, opts);
    }
    else if (_.isObject(input)) {
        result = input;
    }
    return result;
};
exports.exceptObject = exceptObject;
//# sourceMappingURL=ObjectUtils.js.map