"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatChildren = exports.appendLevel = void 0;
const _ = require("lodash");
const DEFAULT_ID_KEY = 'organizationCode';
const DEFAULT_PARENT_KEY = 'parentOrganizationCode';
const DEFAULT_CHIILDREN_KEY = 'children';
const DEFAULT_LEVEL_KEY = 'level';
const DEFAULT_LEVEL_FOR_NO_LEVEL = -1;
const appendLevel = ({ list = [], levelKey = DEFAULT_LEVEL_KEY, level = 0 }) => _.map(list, p => (Object.assign(Object.assign({}, p), { [levelKey]: level })));
exports.appendLevel = appendLevel;
const formatChildren = ({ list, parent, idKey = DEFAULT_ID_KEY, parentKey = DEFAULT_PARENT_KEY, level = DEFAULT_LEVEL_FOR_NO_LEVEL, levelKey = DEFAULT_LEVEL_KEY, childrenKey = DEFAULT_CHIILDREN_KEY }) => {
    if (!parent[idKey]) {
        console.warn(`parent has not id:[${idKey}]..., parent:${JSON.stringify(parent)}`);
        return list;
    }
    const children = _.filter(list, l => l[parentKey] === parent[idKey]);
    _.each(children, parent => formatChildren({
        list, idKey, parentKey, parent, level: (~level) ? level + 1 : -1, levelKey, childrenKey
    }));
    if (!_.isEmpty(children)) {
        parent[childrenKey] = ((~level) ? appendLevel({ list: children, level, levelKey }) : children);
    }
    return parent;
};
exports.formatChildren = formatChildren;
//# sourceMappingURL=TreeUtils.js.map